/*
   $Id: pkgs_array.c,v 1.1.1.1 2000/11/05 22:14:59 pawelk Exp $
   (c) Pawel Kolodziej <pawelk@pld.org.pl>
 */

#include <stdlib.h>
#include <string.h>
#include "rpmmen.h"
#include "rpmmen_config.h"
#include <trurl/trurl.h>
#include "pkgs_array.h"


void free_TPkgInfo(void *a)
{
	TPkgInfo *b;

	n_assert(a != NULL);

	b = (TPkgInfo *) a;
	free(b->fname);
	free(b->name);
	if (b->flags & TPKGINF_HASHDR)
		headerFree(b->h);
	free(b);
}

void *dup_TPkgInfo(void *a)
{
	TPkgInfo *b, *ret;

	n_assert(a != NULL);

	b = (TPkgInfo *) a;

	ret = (TPkgInfo *) malloc(sizeof(TPkgInfo));
	if (b->flags & TPKGINF_HASHDR)
		ret->h = headerCopy(b->h);
	ret->flags = b->flags;
	ret->selected = b->selected;
	ret->fname = strdup(b->fname);
	ret->name = strdup(b->name);

	return ret;
}

int cmp_TPkgInfo(const void *aa, const void *bb)
{
	TPkgInfo *a, *b;
	a = (TPkgInfo *) aa;
	b = (TPkgInfo *) bb;
	return (strcmp(a->name, b->name));
}

int pkgs_array_num(const TPkgSet *p)
{
	return n_array_size(p->packages);
}

TPkgInfo *pkgs_array_nth(const TPkgSet *p, int i)
{
	return (TPkgInfo *) n_array_nth(p->packages, i);
}

tn_array *pkgs_array_new(void)
{
	return n_array_new(RPMMEN_DEF_SIZE,
			   free_TPkgInfo,
			   cmp_TPkgInfo);
}
